	
	var front = document.getElementById("front"),
 		back  = document.getElementById("back"),
		base_size = 360;
	
	if (window.widget) {
	
		var gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hideBack),
			gInfoButton = new AppleInfoButton(document.getElementById("infoButton"),front, "white", "black", showBack),
			gFPSSlider  = new AppleHorizontalSlider(document.getElementById("mySlider"), sliderChanged),
			gSizeSlider  = new AppleHorizontalSlider(document.getElementById("SizeSlider"), sliderChanged);
			
	}else{
		$("#back").fadeIn();
		transferPrefsFromWindow();
		$("#xfer_button").fadeIn();
	}
	

	function showBack() {
		
		if (window.widget) {
			widget.prepareForTransition("ToBack");
			setTimeout('widget.performTransition();', 1)
		}
		
		transferPrefsFromWindow();
		window.Processing.data.pause();
		
		front.style.display="none";
		back.style.display="block";
	}
	
	function xfer_click(){
		transferPrefsToWindow();
		window.Processing.data.restart();
		
	}


	
	function hideBack() {
		
		var fps_changed = false;
		var size_changed = false;
		
		
		if (window.widget) {
			widget.prepareForTransition("ToFront");
			setTimeout('widget.performTransition();', 1);

			if (gFPSSlider.value != window.Processing.data.fps)
				fps_changed = true;
			if (((gSizeSlider.value)+0.5) != window.Processing.data.rel_size)
				size_changed = true;
		
		}
			
		transferPrefsToWindow();
		savePrefs();

		//now change sizes if requested
		if (size_changed){
			change_size();
		}
		
		if (fps_changed)	
			window.Processing.data.reInit();
		else
			window.Processing.data.restart();
		
		window.Processing.data.unpause();
		back.style.display="none";
		front.style.display="block";		
		
	}

	function change_size(){
		if (!window.widget) 
			return;

		var new_size = Math.round(base_size * window.Processing.data.rel_size);
		window.resizeTo(new_size, new_size);
		$("#front").height(new_size);
		$("#front").width(new_size);
		$("#back").height(new_size);
		$("#back").width(new_size);
		$("#axis_pic").height(Math.round(50 * window.Processing.data.rel_size));
		$("#axis_pic").width(Math.round(88 * window.Processing.data.rel_size));
		$("body").css('font-size', Math.round(10 * window.Processing.data.rel_size) + 'px');
		$("#mySlider").width(Math.round(150 * window.Processing.data.rel_size));
		$("#SizeSlider").width(Math.round(150 * window.Processing.data.rel_size));
		
	}

	function transferPrefsToWindow(){
		window.Processing.data.colors 		=  ($("#colors").attr('checked')) ? true : false;
	    window.Processing.data.labels 		=  ($("#labels_cb").attr('checked')) ? true : false;
	    window.Processing.data.legend 		=  ($("#legend_cb").attr('checked')) ? true : false;
	    window.Processing.data.show_fps	 	=  ($("#fps_cb").attr('checked')) ? true : false;
		window.Processing.data.vals 		=  ($("#vals").attr('checked')) ? true : false;
	    window.Processing.data.pause_hidden =  ($("#pause_hidden").attr('checked')) ? true : false;
		window.Processing.data.flips[0] 	=  ($("#flip_x").attr('checked')) ? true : false;
		window.Processing.data.flips[1] 	=  ($("#flip_y").attr('checked')) ? true : false;
		window.Processing.data.flips[2] 	=  ($("#flip_z").attr('checked')) ? true : false;
		window.Processing.data.line_style	=  null;
		window.Processing.data.line_style 	=  $("#line_style").val();
		window.Processing.data.delta_z	 	=  parseFloat($("#delta_z").val());

		if (window.widget){
			window.Processing.data.fps 		= gFPSSlider.value;
			window.Processing.data.rel_size =  (gSizeSlider.value)+0.5;
		}					 
		
	}

	function transferPrefsFromWindow(){
	
		$("#line_style").val(window.Processing.data.line_style);
	    $("#colors").attr('checked', window.Processing.data.colors);
	    $("#labels_cb").attr('checked', window.Processing.data.labels);
	    $("#legend_cb").attr('checked', window.Processing.data.legend);
		$("#fps_cb").attr('checked', window.Processing.data.show_fps);
		$("#vals").attr('checked', window.Processing.data.vals);
		$("#pause_hidden").attr('checked', window.Processing.data.pause_hidden);
		$("#flip_x").attr('checked', window.Processing.data.flips[0]);
		$("#flip_y").attr('checked', window.Processing.data.flips[1]);
		$("#flip_z").attr('checked', window.Processing.data.flips[2]);
		$("#delta_z").val(window.Processing.data.delta_z);

		if (window.widget){
			gFPSSlider.setValue(window.Processing.data.fps);
			gSizeSlider.setValue((window.Processing.data.rel_size-0.5));
		}
		
	}
	
	
	function sliderChanged(currentValue) { 
	}

